"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getStatusInfo = void 0;
const index_1 = require("./index");
function getStatusInfo() {
    try {
        const result = {
            adminPrivileges: index_1.sso.hasAdminPrivileges(),
            isOnDomain: index_1.sso.isOnDomain(),
            domain: index_1.sso.getDefaultDomain(),
        };
        if (index_1.sso.isOnDomain()) {
            result.isActiveDirectoryReachable = index_1.sso.isActiveDirectoryReachable();
        }
        return result;
    }
    catch (e) {
        return {
            error: e,
        };
    }
}
exports.getStatusInfo = getStatusInfo;
//# sourceMappingURL=status.js.map